> ## Documentation Index
> Fetch the complete documentation index at: https://developers.circle.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Event Monitor

> Create a new event monitor based on the provided blockchain, contract address, and event signature.



## OpenAPI

````yaml openapi/smart-contract-platform.yaml post /v1/w3s/contracts/monitors
openapi: 3.0.3
info:
  description: This is the Circle Contracts API documentation.
  title: Circle Contracts
  version: '1.0'
servers:
  - url: https://api.circle.com
security:
  - BearerAuth: []
tags:
  - name: Templates
  - name: View / Update
  - name: Interact
  - name: Deploy / Import
  - name: Event Monitors
paths:
  /v1/w3s/contracts/monitors:
    post:
      tags:
        - Event Monitors
      summary: Create Event Monitor
      description: >-
        Create a new event monitor based on the provided blockchain, contract
        address, and event signature.
      operationId: createEventMonitor
      parameters:
        - $ref: '#/components/parameters/XRequestId'
      requestBody:
        $ref: '#/components/requestBodies/CreateEventMonitor'
        required: true
      responses:
        '200':
          description: Event monitor already exists.
          headers:
            X-Request-Id:
              $ref: '#/components/headers/XRequestId'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EventMonitorResponse'
        '201':
          description: Event monitor created successfully.
          headers:
            X-Request-Id:
              $ref: '#/components/headers/XRequestId'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EventMonitorResponse'
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
          description: Invalid request payload.
          headers:
            X-Request-Id:
              $ref: '#/components/headers/XRequestId'
      security:
        - BearerAuth: []
components:
  parameters:
    XRequestId:
      name: X-Request-Id
      in: header
      description: >
        Developer-provided identifier for this request, used for tracing
        requests in Wallets API logs and the Developer Console, and when
        communicating with Circle Support.

        **Must be a UUID to appear in logs.** Non-UUID values are accepted by
        the API but are ignored by logging and tracing systems.
      schema:
        $ref: '#/components/schemas/XRequestId'
  requestBodies:
    CreateEventMonitor:
      content:
        application/json:
          schema:
            title: CreateEventMonitorRequest
            type: object
            required:
              - blockchain
              - contractAddress
              - eventSignature
              - idempotencyKey
            properties:
              blockchain:
                allOf:
                  - $ref: '#/components/schemas/Blockchain'
              contractAddress:
                $ref: '#/components/schemas/ContractAddress'
              eventSignature:
                type: string
                description: >-
                  The specific event to which you want to subscribeven. Please
                  ensure no spaces are included.
              idempotencyKey:
                $ref: '#/components/schemas/IdempotencyKey'
          examples:
            CreateEventMonitorRequest:
              value:
                blockchain: ETH
                contractAddress: '0x6bc50ff08414717f000431558c0b585332c2a53d'
                eventSignature: Transfer(address,address,uint256)
                idempotencyKey: a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11
      description: Create Event Monitor Request
  headers:
    XRequestId:
      description: >
        Developer-provided header parameter or Circle-generated universally
        unique identifier (UUID v4). Useful for identifying a specific request
        when communicating with Circle Support.
      schema:
        $ref: '#/components/schemas/XRequestId'
  schemas:
    EventMonitorResponse:
      title: EventMonitorResponse
      type: object
      required:
        - data
      properties:
        data:
          type: object
          required:
            - eventMonitor
          properties:
            eventMonitor:
              $ref: '#/components/schemas/EventMonitor'
    Error:
      title: Error
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: integer
          description: Code that corresponds to the error.
        message:
          type: string
          description: Message that describes the error.
    XRequestId:
      type: string
      format: uuid
      description: >-
        A unique identifier, which can be helpful for identifying a request when
        communicating with Circle support.
      example: 2adba88e-9d63-44bc-b975-9b6ae3440dde
    Blockchain:
      type: string
      description: >
        The blockchain network that the resource is to be created on or is
        currently on. 

        Required along with `sourceAddress` if you don't provide `walletId`. The
        `blockchain` and `walletId` fields are mutually exclusive.
      enum:
        - ETH
        - ETH-SEPOLIA
        - MATIC
        - MATIC-AMOY
        - ARB
        - ARB-SEPOLIA
        - UNI
        - UNI-SEPOLIA
        - BASE
        - BASE-SEPOLIA
        - OP
        - OP-SEPOLIA
        - AVAX
        - AVAX-FUJI
        - ARC-TESTNET
        - MONAD
        - MONAD-TESTNET
      example: MATIC-AMOY
    ContractAddress:
      type: string
      description: The on-chain address of this contract.
      example: '0x1e124d7384cd34448ea5907bd0052a79355ab5eb'
    IdempotencyKey:
      type: string
      description: >-
        Universally unique identifier (UUID v4) idempotency key. This key is
        utilized to ensure exactly-once execution of mutating requests. To
        create a UUIDv4 go to
        [uuidgenerator.net](https://www.uuidgenerator.net). If the same key is
        reused, it will be treated as the same request and the original response
        will be returned.
      example: a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11
      format: uuid
    EventMonitor:
      type: object
      required:
        - id
        - blockchain
        - contractAddress
        - eventSignature
        - eventSignatureHash
        - isEnabled
        - createDate
        - updateDate
      properties:
        id:
          type: string
          format: uuid
          example: e3c998a5-bdf1-4f3e-812f-24da238c0fff
        blockchain:
          allOf:
            - $ref: '#/components/schemas/Blockchain'
        contractAddress:
          $ref: '#/components/schemas/ContractAddress'
        eventSignature:
          type: string
          example: Transfer(address indexed from, address indexed to, uint256 value)
        eventSignatureHash:
          type: string
          example: '0xd3d3dd4b1fd3e53f94deb24e763485b4c925345c5abfa9ad529c67aa55a3b784'
        isEnabled:
          type: boolean
          example: true
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: PREFIX:ID:SECRET
      description: >-
        Circle's API Keys are formatted in the following structure
        "PREFIX:ID:SECRET". All three parts are required to make a successful
        request.

````